﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CAN_2015C_demo
{
    public partial class Form1 : Form
    {
        //Global Variable for time value, last temperature value and timer
        Byte VxCAN_port;
        int count;
        float TempLast=0;
        int t_max = 100, t_min = -100;
        Graphics g;
        Pen p;
        Bitmap b = new Bitmap(610,254);
        System.Windows.Forms.Timer Timer1 = new System.Windows.Forms.Timer();

        public Form1()
        {
            InitializeComponent();
            Timer1.Tick += new EventHandler(Timer1_Tick);
        }

        //get VxCAN_DotNET.dll version
        private void Btn_GetDLLVersion_Click(object sender, EventArgs e)
        {
            UInt32 ret;
            Char[] ch = new Char[600];

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_DLL_Ver(ch);
            if (ret == 0)
            {
                String _str = new String(ch);
                MessageBox.Show(_str);
            } 
        }


        private void Btn_SearchModule_Click(object sender, EventArgs e)
        {
            UInt32 ret;
            byte Percentage = 0;
            pBar_SearchModule.Value = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_SearchCANModule();
            if (ret == 0)
            {
                while (pBar_SearchModule.Value < pBar_SearchModule.Maximum)
                {

                    ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_IsSearchCANModuleOK(ref Percentage);
                    pBar_SearchModule.Value = Convert.ToInt32(Percentage);
                }

                MessageBox.Show("Search Done!");
            }
        }

        private void Btn_GetModuleList_Click(object sender, EventArgs e)
        {
            Byte _TotalVxCANPort = 0;
            Byte[] _VxCAN_LocalPortIDList = new Byte[50];
            UInt32 ret = 0;
            UInt32[] _VxCAN_NameIDList = new UInt32[50];
            UInt32[] _VxCAN_IDList = new UInt32[50];
            UInt32[] _VxCAN_COMPortBaudRate = new UInt32[50];
            String[] _VxCAN_NameStr = new String[50];
            String[] _VxCAN_VerStr = new String[50];

            dataGridView1.Columns.Clear();
            dataGridView1.Rows.Clear();
            dataGridView1.Columns.Add("VxCANPort", "VxCANPort");
            dataGridView1.Columns.Add("VxCAN_NameIDList", "VxCAN_NameIDList");
            dataGridView1.Columns.Add("VxCAN_IDList", "VxCAN_IDList");
            dataGridView1.Columns.Add("VxCAN_COMPortBaudRate", "VxCAN_COMPortBaudRate");
            dataGridView1.Columns.Add("VxCAN_NameStr", "VxCAN_NameStr");
            dataGridView1.Columns.Add("VxCAN_VerStr", "VxCAN_VerStr");
            dataGridView1.Columns.Add("VxCAN_LocalPortIDList", "VxCAN_LocalPortIDList");



            for (int i = 0; i < 50; i++)
            {
                //Set Default Value
                _VxCAN_NameStr[i] = new String('\0', 50);
                _VxCAN_VerStr[i] = new String('\0', 50);
            }



            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_TotalCANPort(ref _TotalVxCANPort, _VxCAN_NameIDList, _VxCAN_IDList, _VxCAN_COMPortBaudRate, _VxCAN_NameStr, _VxCAN_VerStr, _VxCAN_LocalPortIDList);
            if (ret == 0)
            {
                for (int i = 0; i < _TotalVxCANPort; i++)
                {
                    dataGridView1.Rows.Add();
                    dataGridView1["VxCANPort", dataGridView1.Rows.Count - 1].Value = i;
                    dataGridView1["VxCAN_NameIDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_NameIDList[i];
                    dataGridView1["VxCAN_NameIDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_NameIDList[i];
                    dataGridView1["VxCAN_IDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_IDList[i];

                    //2015C is not a UART module so its VxCAN_COMPortBaudRate = 0xFFFFFFFF
                    //we use -1 to represent that
                    if (_VxCAN_COMPortBaudRate[i] == 0xFFFFFFFF)
                        dataGridView1["VxCAN_COMPortBaudRate", dataGridView1.Rows.Count - 1].Value = -1;
                    else
                        dataGridView1["VxCAN_COMPortBaudRate", dataGridView1.Rows.Count - 1].Value = _VxCAN_COMPortBaudRate[i];
                    dataGridView1["VxCAN_NameStr", dataGridView1.Rows.Count - 1].Value = _VxCAN_NameStr[i];
                    dataGridView1["VxCAN_VerStr", dataGridView1.Rows.Count - 1].Value = _VxCAN_VerStr[i];
                    dataGridView1["VxCAN_LocalPortIDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_LocalPortIDList[i];
                }
            }
        }
        //default CAN baud rate is 1000Kbps, use that open CAN port
        private void Btn_OpenCAN_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_OpenCAN((Byte)dataGridView1.CurrentRow.Index, (UInt32)VxCAN_DotNET.VxCAN_DotNET.CAN_BaudRate.BR_1000K);
            if (ret == 0)
            {
                MessageBox.Show("Open CAN Port 0 done!!");
            }
            VxCAN_port = (Byte)dataGridView1.CurrentRow.Index;
            rtd_type.SelectedIndex=0;
        }
        //close CAN port
        private void Btn_CloseCAN_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(VxCAN_port);
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearTxBuffer(VxCAN_port);
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_CloseCAN(VxCAN_port);
        }

        private void Btn_ResetCAN_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_ResetCAN(0);
            if (ret == 0)
                MessageBox.Show("Reset CAN Port 0 done!");
        }

        private void Btn_CANStatus_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;
            UInt32 ModuleStatus = 0;
            UInt32 CANChipStatus = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_CANStatus(0, ref ModuleStatus, ref CANChipStatus);
            if (ret == 0)
            {
                MessageBox.Show("Module Status = " + ModuleStatus.ToString());
                MessageBox.Show("CAN Chip Status = " + CANChipStatus.ToString());
            }
        }

        private void Btn_SendCANMsg_Click(object sender, EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID = (Byte)(comboBox1.SelectedIndex + 1);
            Byte VxCANPort = VxCAN_port, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ID = 0x000;
            Byte[] Data = new Byte[8];
            int index;
            int RTD_Type = 0x20;
            index = rtd_type.SelectedIndex;
            g = Graphics.FromImage(b);
            g.Clear(Color.White);

            //Clean buffer for Latest Data
            //VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(VxCANPort);

            if (index <= 15)
                RTD_Type += index;
            else if (index == 16)
                RTD_Type = 0x80;
            else if (index == 17)
                RTD_Type = 0x81;

            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2F;
            Data[1] = 0x04;
            Data[2] = 0x20;
            Data[3] = 0x01;
            Data[4] = (byte)RTD_Type;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

            switch (index)
            {
                case 0:
                    t_max = 100;
                    t_min = -100;
                    break;
                case 1:
                    t_max = 100;
                    t_min = 0;
                    break;
                case 2:
                    t_max = 200;
                    t_min = 0;
                    break;
                case 3:
                    t_max = 600;
                    t_min = 0;
                    break;
                case 4:
                    t_max = 100;
                    t_min = -100;
                    break;
                case 5:
                    t_max = 100;
                    t_min = 0;
                    break;
                case 6:
                    t_max = 200;
                    t_min = 0;
                    break;
                case 7:
                    t_max = 600;
                    t_min = 0;
                    break;
                case 8:
                    t_max = 100;
                    t_min = -80;
                    break;
                case 9:
                    t_max = 100;
                    t_min = 0;
                    break;
                case 10:
                    t_max = 600;
                    t_min = -200;
                    break;
                case 11:
                    t_max = 150;
                    t_min = -20;
                    break;
                case 12:
                    t_max = 200;
                    t_min = 0;
                    break;
                case 13:
                    t_max = 150;
                    t_min = -20;
                    break;
                case 14:
                    t_max = 200;
                    t_min = -200;
                    break;
                case 15:
                    t_max = 200;
                    t_min = -200;
                    break;
                case 16:
                    t_max = 600;
                    t_min = -200;
                    break;
                case 17:
                    t_max = 600;
                    t_min = -200;
                    break;
            }
            Draw_Background();

            //Set 1 second interval of event timer 
            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2B;
            Data[1] = 0x01;
            Data[2] = 0x18;
            Data[3] = 0x05;
            Data[4] = 0xE8;
            Data[5] = 0x03;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);
            
            count = 0;
            Timer1.Interval = 1000;
            Timer1.Enabled = true;
            
            

        }

        private void Btn_SendStopMsg_Click(object sender, EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID = (Byte)(comboBox1.SelectedIndex + 1);
            Byte VxCANPort = VxCAN_port, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ret = 0, ID = 0x000;
            Byte[] Data = new Byte[8];
						
			//Set 0 second interval of event timer to disable event timer
			ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2B;
            Data[1] = 0x01;
            Data[2] = 0x18;
            Data[3] = 0x05;
            Data[4] = 0x00;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);		
			if (ret != 0)
            {
                MessageBox.Show("Close Event Timer Fail!!");
            }	
			
			//Stop timer
			Timer1.Enabled = false;

           
        }
        

        private void Timer1_Tick(object sender, System.EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            byte VxCANPort = VxCAN_port, rMode = 0, rRTR = 0, rLen = 0;
            byte[] rData = new Byte[8];
            UInt32 ret = 0, rID = 0;
            Double rMsgTimeStamps = 0;
            double T = 0;
            float Temp = 0;
            int a = 0x0;    //hexadecimal temperature data
            
            //Initialize graphics
            System.Drawing.SolidBrush drawBrush = new System.Drawing.SolidBrush(System.Drawing.Color.Black);
            g = Graphics.FromImage(b);
            Pen p = new Pen(Color.Black, 3);
            
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_Receive(VxCANPort, ref rID, ref rMode, ref rRTR, ref rLen, rData, ref rMsgTimeStamps);
            if (ret == 0)
            {
                //Clean buffer for Latest Data
                VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(VxCANPort);

                if (rID == (0x280 + NumID))
                {
                    //Convert input data to the corresponding temperature value and formula is below
                    a = rData[1] * 256 + rData[0];
                    if (a >= 0x8000)
                    {
                        a = 0xFFFF - a + 1;
                        a = -a;
                    }
                    T = a * t_max * 2 / 65535.0;
                    Temp = (float)Math.Round(T, 2);

                    //Reset graphics when 60 seconds of arrival 
                    if (count == 60 || count == 0)
                    {
                        count = 0;
                        Draw_Background();
                    }

                    //let temperature be bounded
                    if (Temp > t_max) 
                        Temp = t_max;
                    if (Temp < t_min)
                        Temp = t_min;

                    textBox2.Text = Temp.ToString() + "°C";
                    textBox3.Text = count.ToString() + "s";

                    //Draw trand chart with black line
                    if (count != 0)
                    {
                        g.DrawLine(p, TOX(count - 1), TOY(TempLast), TOX(count), TOY(Temp));
                        pictureBox1.Refresh();
                        
                    }

                    //increase time and record last temperature value for trend chart
                    count++;
                    TempLast = Temp;
                }
                

            }
            

            
           
        }

        //To fit the graphics scale of X axis
        float TOX(float a1)
        {
            float x;
            x = 5 + (pictureBox1.Width - 10) / (float)(60.0) * a1;
            return x;
        }

        //To fit the graphics scale of Y axis 
        float TOY(float b1)
        {
            float y;
            y = (pictureBox1.Height - 15) / 2 + 5 - ((pictureBox1.Height - 15) / 2 - 0) / (float)(t_max) * b1;
            return y;
        }
        //Start operation mode
        private void button1_Click(object sender, EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID = (Byte)(comboBox1.SelectedIndex + 1);
            Byte VxCANPort = VxCAN_port, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ID = 0x000;
            Byte[] Data = new Byte[8];

            ID = 0x000;
            Len = 0x2;
            Data[0] = 0x01;
            Data[1] = DataID;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);
            MessageBox.Show("CAN2015C is in operation mode!");
                

        }
        private void Draw_Background()
        {
            int a;
            g.Clear(Color.White);
            p = new Pen(Color.Blue, 2);
            a = t_max / 4;

            //label for temperature range 
            label8.Text = t_max.ToString() + " °C";
            label12.Text = (a * 3).ToString() + " °C";
            label13.Text = (a * 2).ToString() + " °C";
            label14.Text = a.ToString() + " °C";
            label15.Text = "0" + "°C";
            label16.Text = (0 - a).ToString() + " °C";
            label17.Text = (0 - a * 2).ToString() + " °C";
            label18.Text = (0 - a * 3).ToString() + " °C";
            label19.Text = (0 - t_max).ToString() + " °C";

            //Draw X Y axis. Limit max time = 60 seconds
            p.DashStyle = DashStyle.Solid;
            p.EndCap = LineCap.ArrowAnchor;
            g.DrawLine(p, 5, 125, 605, 125);
            g.DrawLine(p, 5, 125, 5, 5);
            g.DrawLine(p, 5, 125, 5, 245);
            //Draw separate line for temperature range
            p.DashStyle = DashStyle.Dash;
            g.DrawLine(p, 5, 5, 605, 5);
            g.DrawLine(p, 5, 35, 605, 35);
            g.DrawLine(p, 5, 65, 605, 65);
            g.DrawLine(p, 5, 95, 605, 95);
            g.DrawLine(p, 5, 155, 605, 155);
            g.DrawLine(p, 5, 185, 605, 185);
            g.DrawLine(p, 5, 215, 605, 215);
            g.DrawLine(p, 5, 245, 605, 245);

        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            pictureBox1.Image = b;
        }
       
    }
}
